#ifndef AMINO_H
#define AMINO_H

#include "basem.h"

class AminoM : public BaseM {
public :
AminoM ();

virtual void init ();

static void writeMat (DMat20 &rate);
static void writeInt (Vec<int> &vec);
static void writeDouble (DVec20 &vec);


/*
cmp the probability of changing from amino acid stateNo1 into amino acid stateNo2
after a period of brLen  
*/
virtual double cmpProbChange (const int stateNo1, const int stateNo2, const double brLen);


//cmp the vector probability of change from stateNo
virtual void cmpProbChange (const int stateNo, const double brLen, DVec20 &probVec);


/*
cmp the array of probability of changing from
one amino acid into one amino acid after a period of brLen 
*/
virtual void cmpProbChange (const double brLen, DMat20 &probMat);



static void elmhes(DMat20 a, Vec<int> &ordr, int n);
static void eltran(DMat20 a, DMat20 zz, Vec<int> &ordr, int n);
static void mcdiv(double ar, double ai, double br, double bi,
                          double *cr, double *ci);

static void hqr2(int n, int low, int hgh, DMat20 h,
                        DMat20 zz, DVec20 &wr, DVec20 &wi);
static void onepamratematrix(DMat20 a);
static void eigensystem(DVec20 &eval, DMat20 &evec);
static void luinverse(DMat20 inmat, DMat20 imtrx, int size);
static void checkevector(DMat20 evec, DMat20 ivec, int nn);
static void tranprobmat();
static void rtfdata (DMat20 &a, DVec20 &forg);
static void convfreq(DVec20 &freqemp);
~AminoM ();
}; //end class

#endif
