#include "cluster.h"
#include "ali.h"

Cluster::Cluster () {
  totalSeqNo_ = 0;
  nObj_ = 0;
  brLen_  = -1.0;
  id_ = -1;
  nSup_ = 1;
}

void Cluster::add (Vec<int> &exNdNoLs, double brLen) {  
  int markArr_[MAX_NUM_SEQ];
  int nSeq_ = Ali::getNSeq ();
  int seqNo_;
  for (seqNo_ = 0; seqNo_ < nSeq_; seqNo_ ++)
    markArr_[seqNo_] = 0;

  for (int count_ = 0; count_ < exNdNoLs.getSize (); count_ ++) 
    markArr_[ exNdNoLs[count_] ] = 1;

  seqNoArr_.set (nSeq_, 0);
  nObj_ = 0;
  totalSeqNo_ = 0;
  for (seqNo_ = 0; seqNo_ < nSeq_; seqNo_ ++)  
     if (markArr_[seqNo_] == markArr_[0]) {
       totalSeqNo_ += seqNo_;
       seqNoArr_ += seqNo_;
       nObj_ ++;
    }
  brLen_ = brLen;  
}

int Cluster::operator == (Cluster &cluster2) {
  if (cluster2.nObj_ != nObj_  || cluster2.totalSeqNo_ != totalSeqNo_)
    return 0;
  for (int count_ = 0; count_ < nObj_; count_ ++)
    if (seqNoArr_[count_] != cluster2.seqNoArr_[count_])
      return 0;
  return 1;
}

int Cluster::operator [] (int index) {
  return seqNoArr_[index];
}

void Cluster::setId (int id) {
  id_ = id;
}

Cluster::~Cluster () {
}
