#ifndef DAYHOFF_H
#define DAYHOFF_H

#include "basem.h"
#include "dmat20.h"
#include "dvec20.h"

class DayhoffM {
public :

	/*
	 * Dayhoff model for amino acid evolution
	 * Dayhoff, M.O., Schwartz, R.M., Orcutt, B.C. (1978)
	 * "A model of evolutionary change in proteins."
	 * Dayhoff, M.O. (ed.) Atlas of Protein Sequence Structur., Vol5, Suppl. 3,
	 * National Biomedical Research Foundation, Washington DC, pp. 345-352.
	 */
void getData (DMat20 &q, DVec20 &f);

}; //end of class
#endif

