#ifndef EXND_H
#define EXND_H

/*the ExNd class contain all necessary information and methods for an internal node
...being specified more
*/

class ExNd 
{
public :
//constructor function for all intializing before using object
ExNd ();

//clean all content of this external node
void clean ();

//set the indentical number for this ex node
void setId (const int Id);

//set the internal node of this external node
void setInNd (const int inNdNo);

//set the br no contacting this node and the internal node
void setBr (const int brNo);

//set all information for this ex node
void set (const int Id, const int inNdNo, const int brNo);

//get the indentical number of this ex node
int getId ();

//get the internal node of this node
int getInNd ();

//get the br no contacting this node and the internal node
int getBr ();

//copy the ex node into the ex node
void copy (ExNd &exNd);

//overload operator =. Thus, copy an internal node into this internal node
void operator = (ExNd &exNd);

//change the internal of this external node
void changeInNd (const int newInNdNo);

//change the branch of this external node
void changeBr (const int newBrNo);

//release all memmory for this class
void release ();

//destructor function for all releasing before deleting object
~ExNd ();

/********************************************************************************************
********************************************************************************************
********************************************************************************************
********************************************************************************************
********************************************************************************************/

private :
//the identical number of this node
int id_;

//the internal node no of this external node
int inNdNo_;

//brNo_ is the br no  between this node and the internalNdNo_
int brNo_;

};  //end of exnd class
#endif
