#ifndef IND_H
#define IND_H

/*the InNd class contain all necessary information
and methods for an in node
...being specified more
*/
#include "vec.h"

class InNd 
{
public :

//constructor function for all intializing before using object
InNd ();

//clean all content of this internal node
void clean ();

//set the indentical number for this in node
void setId (const int Id);

//check if this ndNo is an external node
int isExNd (int ndNo);

int getSibNd (int sibNdNo);

//set the maximum number of external nodes
void setMaxNExNd (const int maxNExNd);

//get the maximum number of external nodes
int getMaxNExNd ();

//get the indentical number of this in node
int getId ();

//return the child node no list of this internal node
Vec<int> &getChiNd ();
 
//all things is inited here
void init ();

//add one nei node of this node
void addNeiNd (int neiNdNo);

//add three nei nodes of this node
void addNeiNd (int neiNdNo0, int neiNdNo1, int neiNdNo2);

//add a br contact this node and one of it's nei node
void addBr (int brNo);

//add three bres contact this node and one of it's nei node
void addBr (int brNo0, int brNo1, int brNo2);

//return the NeiNdLs_
Vec<int> &getNeiNd ();

//return the brNoLs_
Vec<int> &getBr ();

//return brNoLs_[index];
int getBr (int index);

//change one nei node of this node
void changeNeiNd (const int oldNeiNdNo, const int newNeiNdNo);

//change one br of this node
void changeBr (const int oldBrNo, const int newBrNo);
     
//copy an in node into this in node
void copy (InNd &inNd);

//overload operator =. Thus,copy an in node into this in node
void operator = (InNd & inNd);

//return neiNdNoLs_[index];
int getNeiNd (int index);

//return the neighbor node no list satisfying neiNdNoLs[0] < neiNdNoLs[1] ...
void getOrderNeiNd (Vec<int> &orderNeiNdNoLs);

//return the internal node no list satisfying smallNeiNdNo < middleNeiNdNo < greatNeiNdNo
void getOrderNeiNd (int &smallNeiNdNo, int &middleNeiNdNo, int &greatNeiNdNo);

//get 2 remain neighbor nodes, and 2 remain branches no of this internal node
void get2RemNeiNdBr (const int existNeiNdNo, int &remNeiNdNo1, int &remBrNo1, int &remNeiNdNo2, int &remBrNo2);

//get 2 remain branch no of this internal node
void get2RemBr (const int existBrNo, int &remBrNo1, int &remBrNo2);

//get 2 remain neighbor nodes no of this internal node
void get2RemNeiNd (const int existNeiNdNo, int &remNeiNdNo1, int &remNeiNdNo2);

/*
order the neighbor node and branch list of this liInNd. 
The first neighbor is the parrent arccording to artInRoot and artExRoot
*/
void orderNeiNd (const int parNdNo);

int findComBr (int neiNdNo);

/*this function set the memory for this class. This function
need argument maxNExNd for direction array
*/
void setLimit (int maxNExNd);

//release all memmory for this class
void release ();

//destructor function for all releasing before deleting object
~InNd ();

/********************************************************************************
********************************************************************************
********************************************************************************
********************************************************************************/
protected :
//the identical number of this node
int id_;

//the list of idenfitication of nei nodes of this node,
Vec<int> neiNdNoLs_;

//the list no of bres contacting to this node
Vec<int> brNoLs_;

//the maximum number of external nodes
int maxNExNd_;


/********************************************************************************
********************************************************************************
********************************************************************************
********************************************************************************/
private :
};
#endif

