#ifndef IQP_H
#define IQP_H

#include <ctime>
#include "constant.h"
#include "vec.h"
#include "urtree.h"
#include "treels.h"
#include "clusterarr.h"

class IQP {
public :
int nSeq_;
int nRep_;
double proSel_;
ClusterArr bestClusterArr_;


//--------------------------------------------------------------------
//we will init all things here before starting testing this method with data
void init ();


double tuneFineParameter (UrTree &bestTree);
void optPam ();

double escape (Vec<int> &orderNdNoLs, UrTree &tree, UrTree &bestTree, ClusterArr &bestClusterArr);
double escapeLocalOpt (int &nIt, double proSel, int nRep, STOPPING_TYPE stoppingRule, UrTree &bestTree,  int outGrpSeqNo, Vec<char> &conTree,  time_t &beginTime_, double &progTime);

void        loadTreeLs (const char *treeLsFileName, int &nIter, ClusterArr &bestClusterArr, ClusterArr &allCluArr, 
                        UrTree &bestTree, double &bestLogLi,
                        int &nImpTree, const char *predictionFileName, double &progTime);

void writePamCheckPoint ( char  *checkPointFileName, 
                        int        nIter,       
                        double     proSel,
                        int        nRep,
                        STOPPING_TYPE     stoppingRule,
                        int         outGrpSeqNo,
                        int         isFinished);
}; //end of class;

#endif

