#ifndef LIBR_H
#define LIBR_H

#include "br.h"
#include "lind.h"

class LiBr : public Br<double>
{
public:
//the constructor
LiBr ();

//smaLiNd, smaNdNo_ ===================greNdNo, greLiNd
LiNd *smaLiNd_;
LiNd *greLiNd_;

double score_;
int isSwapLChi_;
int isCan_, isSwap_;
void writeInf ();

//copy the base br into this likelihood branch
void copyBase (Br<double> &br);

void setTailLiNd (LiNd *newTailLiNd);

//get the remaining liNd of this branch
LiNd &getRemLiNd (int existNdNo);

//get the sma liNd of this branch
LiNd &getSmaLiNd ();

//get the gre liNd of this branch
LiNd &getGreLiNd ();

//get the tail liNd of this branch
LiNd &getTailLiNd ();

//get the head liNd of this branch
LiNd &getHeadLiNd ();

LiNd &getLiNd (int ndNo);

int isOutGrp ();

//create the pattern for all liNds of this branch
void createExDesLiNd ();

//set the two liNds to be NOT cmped
void openLiNd ();

//set the tail liNd to be Not cmped
void openTailLiNd ();

//set the tail liNd to be Not cmped
void openHeadLiNd ();

//compute the likelihood for liNd of this branch
void cmpLiNd (int ndNo);

//compute the likelihood for tail liNd of this branch
void cmpTailLiNd ();

//compute the likelihood for head liNd of this branch
void cmpHeadLiNd ();

//reCompute the likelihood for tail liNd of this branch
void reCmpTailLiNd ();

//reCompute the likelihood for head liNd of this branch
void reCmpHeadLiNd ();

//compute the likelihood along this branch
double cmpLi (int ptnNo, int rateNo, int parBaseNo, int parNdNo);


//compute the log likelihood of this tree via this an external branch
double cmpInLogLiUniformRate ();

//compute the log likelihood of this tree via this an external branch
double cmpInLogLiSpecificRate ();

//compute the log likelihood of this tree via this an external branch
double cmpInLogLiGammaRate ();

//compute the log likelihood of this tree via this an external branch in case of one rate
double cmpExLogLiUniformRate ();

//compute the log likelihood of this tree via this an external branch in case of one rate
double cmpExLogLiSpecificRate ();

//compute the log likelihood of this tree via this an external branch in case of one rate
double cmpExLogLiGammaRate ();

double cmpExLogLi ();

double cmpInLogLi ();

//set memory for this liBr
void setLimit ();

//release all memory of this class

void release ();

//the destructor
virtual ~LiBr ();
};
#endif
