/***************************************************************************
                          librarr.h  -  description
                             -------------------
    begin                : Thu Apr 24 2003
    copyright            : (C) 2003 by 
    email                : vinh@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef LIBRARR_H
#define LIBRARR_H
#include "vec.h"
#include "libr.h"
#include "brarr.h"

//this is a collection of liBr of the optUrTree
class LiBrArr
{
public:
//the constructor function
LiBrArr ();

//all things are inited here
void init ();

//return maximum number of branches in this class
int getMaxNBr ();

//copy all information of brArr into this llhBrArr
void copyBase (BrArr<double> &brArr);

//return items_[index]
LiBr &operator[] (const int index);

//return the current number of liBrs of this array
int getCurNBr ();

//release all memmory for this class
void release ();

//the destructor function
virtual ~LiBrArr ();


/**************************************************************/
private :
//the current number of likelihood branchs of this class
int curNBr_;

//the maximum number of likelihood branchs of this class
int maxNBr_;

static Vec<LiBr> items_;
}; //end of class

#endif
