// lind.h: interface for the LiNd class.
//
//////////////////////////////////////////////////////////////////////

#ifndef LIND_H
#define LIND_H

#include "innd.h"
#include "vec.h"
#include "cube.h"



/*
this class contain all information information of likelihood at this node
*/
class LiNd
{
public:
//the constructor function
LiNd ();

/*liCube_[ptnNo][rateNo][baseNo] is the likelihood at 
this node coressponding to ptnNo, rateNo, baseNo
*/
Cube liNdCube_;

int isEx_;
int id_;

//parNdNo_ of this likelihood node
int parNdNo_;

//parNdNo_ of this likelihood node
int parBrNo_;

int isExDesNdCreated_;
Vec<int> exDesNdNoLs_;
    
int isCmped_;

void writeInf ();

//set the  id, ndType, parrent node, and branch no for this node
void set (int id, EX_IN ndType, int parNdNo, int parBrNo);

int getId ();

Vec<int> &getExDesNd ();

void turnOffIsCmped ();

void setParNdBr (int newParNdNo, int newParBrNo);

//return the likelihood of these arguments
long double cmpLi (int ptnNo, int rateNo, int baseNo);


//--------------------------------------------------------------------
//return the likelihood of these argument
inline long double getLiNd (int ptnNo, int rateNo, int baseNo) {  
  return liNdCube_[ptnNo][rateNo][baseNo];
}

//get the parrent node, and branch no for this node
void getPar (int &parNdNo, int &parBrNo);

//compute the likelihood for all ptnNo, rateNo, baseNo at this node 
void cmpLi ();


//compute the likelihood for all ptnNo, rateNo, baseNo at this node 
void cmpLiUniformRate ();

//compute the likelihood for all ptnNo, rateNo, baseNo at this node 
void cmpLiSpecificRate ();

//compute the likelihood for all ptnNo, rateNo, baseNo at this node 
void cmpLiGammaRate ();

//reCompute the likelihood for all ptnNo, rateNo, baseNo of this node 
void reCmpLi ();


//create the external descendant nodes no list of this node
void createExDesNd (Vec<int> &exDesNdNoLs);

//create the external descendant nodes no list of this node
void createExDesNd ();

//set memory for this class
void setLimit ();

//release the memory of this class
void release ();

//the destructor function
virtual ~LiNd ();

};// end of class

#endif //LIINND
