#ifndef OPTPAIRSEQ_H
#define OPTPAIRSEQ_H

#include "seq.h"
#include "mat.h"

//using this class to optimize the distance between two sequences
class OptPairSeq 
{
public :
//the constructor function
OptPairSeq ();

//use this function for constructing this class
static void doConstructor ();

//compute the gen distance between two sequences
static double cmp (Seq &seq1, Seq &seq2, double initGenDis = -1.0);

//release all memmory for this class
void release ();

//the destructor function
virtual ~OptPairSeq ();

/********************************************************************
********************************************************************
********************************************************************
********************************************************************
********************************************************************/
private :
//the pointer to the two sequences which we want to optimize their distance
static Seq *seq1_;
static Seq *seq2_;

//create the pair pattern matrix of two sequences
static void createPairPtn ();

//ptnMat[baseNo1][baseNo1] = f, it means that (baseNo1, baseNo2) appears f times
static int ptnMat_[NUM_CAN_STATE][NUM_CAN_STATE];

//compute the observed distance between two sequences
static double cmpObsDis (Seq &seq1, Seq &seq2);

//compute the negative log likelihood when the distance between them is brLen
static double cmpLogLiSpecificRate(double brLen);

//compute the negative log likelihood when the distance between them is brLen
static double cmpLogLiGammaRate(double brLen);

//compute the negative log likelihood when the distance between them is time
static double cmpNegLogLi(double time);

}; // end of class
#endif
