/***************************************************************************
                          prediction.h  -  description
                             -------------------
    begin                : Fri Nov 28 2003
    copyright            : (C) 2003 by Le Sy Vinh & Arndt von Haeseler
    email                : vinh@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREDICTION_H
#define PREDICTION_H

#include "vec.h"
#include "mat.h"


class Prediction {
public :

double predict (const char *fileName, double confidentVal, double & upperTime);

private :

int nTime_;
Vec<double> timeVec_;

void cmpInvMat (Mat<double> &oriMat, Mat<double> &invMat, int size);

void readMat (char *fileName, Mat<double> &oriMat, int &size);

void multiple (Mat<double> &mat1, Mat<double> &mat2, Mat<double> &proMat);


void multiple (Mat<double> &mat1, Vec<double> &vec2, Vec<double> &proVec);

void multiple (Vec<double> &vec1, Mat<double> &mat2, Vec<double> &proVec);
void multiple (Vec<double> &vec1, Vec<double> &vec2, Mat<double> &proMat);
double multiple (Vec<double> &vec1, Vec<double> &vec2);

/* THE FOLLOWING CODE COMES FROM tools.c in Yang's PAML package */
//----------------------------------------------------------------------------------------
double cmpLnGamma (double alpha);

void readFile (const char *fileName);

double cmpMuy (int k);
double cmpGamma (double alpha);

void cmpLamdaMat (int k, Mat<double> &lamdaMat);

void cmpVecA (int k, Vec<double> &aVec);

double cmpExtinctTime (int k);
double cmpUpperTime (int k, double alpha);
};

#endif
