// Ptn.cpp: implementation of the Ptn class.
//
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include "constant.h"
#include "ptn.h"


//the constructor function
Ptn::Ptn () {
  clean ();
}

//clean all remember flags of this class
void Ptn::clean () {
}

//--------------------------------------------------------------------
//set the siteNo for this ptn
void Ptn::setSite (const int siteNo) {
  siteNo_ = siteNo;
}

//--------------------------------------------------------------------
//set limit for this ptn. Thus, set the maximum number of nucleotides or amino acids of this pattern
void Ptn::setLimit (const int limit) {
  items_.setLimit (limit);
}

//--------------------------------------------------------------------
//set the exact number of nucleotides or amino acids of this pattern
void Ptn::setSize (const int limit) {
  items_.set (limit, limit);
}

//--------------------------------------------------------------------
//get the siteNo of this ptn
int Ptn::getSite () {
  return siteNo_;
}

//--------------------------------------------------------------------
//set the content of this ptn
void Ptn::set (Vec<char> &items) {
  items_ = items;
}

//--------------------------------------------------------------------
//set the number of sites which have the same ptn to this one
void Ptn::setWeight (const int weight) {
  weight_ = weight;
}

//--------------------------------------------------------------------
//get the number of sites which have the same ptn to this one
int Ptn::getWeight () {
  return weight_;
}

//--------------------------------------------------------------------
//get the content of this ptn.
Vec<char> &Ptn::getItem () {
  return items_;
}

//--------------------------------------------------------------------
//return items_[index]
char Ptn::getItem (const int index) {
  return items_[index];
}

//--------------------------------------------------------------------
//return items_[index]

char &Ptn::operator [] (const int index) {
  return items_[index];
}

//--------------------------------------------------------------------
//overload == operator
int Ptn::operator == (Ptn &ptn) {
  for (int seqNo_ = 0; seqNo_ < items_.getSize (); seqNo_++)
    if (this->items_[seqNo_] != ptn[seqNo_] )
      return 0;
  return 1;
}

//--------------------------------------------------------------------
//overload += operator, weight = weight + incWeight
void Ptn::operator += (char base) {
  items_ += base;
}

//--------------------------------------------------------------------
//weight_ = weight_ + increment
void Ptn::addWeight (const int incWeight) {
  weight_ += incWeight;
}

//--------------------------------------------------------------------
//overload operator =
void Ptn::operator = (Ptn &ptn) {
  this->siteNo_ = ptn.getSite ();
  this->weight_ = ptn.getWeight ();
  this->items_ = ptn.getItem ();  
}


//--------------------------------------------------------------------
//release all meory of this class
void Ptn::release () {
  items_.release ();
}

//--------------------------------------------------------------------
//the destructor function
Ptn::~Ptn () {
  release ();
//  std::cout << "the destructor of Ptn class " << endl;
}
