#ifndef PTN_H
#define PTN_H

/*the discription of this ptn class. The content of the ptn class is to get from the Alingment class */
#include "vec.h"

class Ptn 
{
public:
//the constructor
Ptn ();

//set limit for this ptn. Thus, set the maximum number of nucleotides or amino acids of this pattern
void setLimit (const int limit);

//set the exact number of nucleotides or amino acids of this pattern
void setSize (const int limit);

//set siteNo for this ptn
void setSite (const int siteNo);

//get the siteNo of this ptn
int getSite ();

//set the number of sites which have the same ptn to this one
void setWeight (const int weight);

//get the number of sites which have the same ptn to this one
int getWeight ();

//some ways to get the content of this ptn. Return the content of this ptn
Vec<char> &getItem ();

//return items_[index]
char getItem(const int index);

//set the content of this ptn
void set (Vec<char> &items);

//overload == operator, check whether or not the input ptn is identical to this ptn
int operator == (Ptn &ptn);

//overload +=
void operator += (char base);

//weight_ = weight_ + increment
void addWeight (const int incWeight);

//overload operator =
void operator = (Ptn &ptn);

//overload operator []
char &operator [] (const int index);

//check the const property of this patter
int isConst ();

//--------------------------------------------------------------------
//write all information of this ptn
template <class Tout>
Tout &write(Tout &out) {
  items_.writeItem (out) << " : " << weight_ << endl;
  return out;
}

//clean all remember flags of this class
void clean ();

//release all memmory for this class
void release ();

//the destructor
virtual ~Ptn ();

//the identification of this ptns
int siteNo_; 

//the content of ptn
Vec<char> items_;

//the number of sites in the alignment having the same ptn
int weight_;
};
#endif 
