#ifndef PTNLS_H
#define PTNLS_H

#include "vec.h"
#include "ptn.h"

//this class contains all patterns of the alignment. Only the active sequences are taken into account
class PtnLs  
{
public:
static int weightArr_[MAX_NUM_PTN];
static int siteArr_[MAX_NUM_PTN];


//the constructor
PtnLs ();

//use this function for constructing this class
static void doConstructor ();

//get the number of sequences
static int getNSeq ();

//get the number of sequences
static void setNSeq (const int nSeq);

//everything will be inited here
static void init ();

//clean all content of this pattern
static void clean ();

/*
create the order site list of all sites of this alignment
such that Ptn (orderSiteNoLs[0]) < Ptn (orderSiteNoLs[1]) <...
*/
static void createOrderSite (Vec<int> *orderSiteNoLs);


// creat the pattern list
static void create ();


//return items_[index]
static Ptn &getPtn (const int index);

//return items_[index]
static Ptn *getPtnPoi (const int index);

//get the number of patterns
static int getNPtn ();

static inline char getBase (int ptnNo, int seqNo) {
  return items_[ptnNo].items_[seqNo];
}

//--------------------------------------------------------------------
//write all information of this ptnls 
template <class Tout>
static Tout &write (Tout &out) {
  for (int ptnNo_ = 0; ptnNo_ < nPtn_; ptnNo_ ++)
    items_[ptnNo_].write (out);
  out << "=============end of this pattern list==========================" << endl;
  out << "this is a NEW WAY to create the PtnLs . . . " << endl;
  out << "the number different patterns is " << nPtn_ << endl;
  return out;
}

//--------------------------------------------------------------------
static inline int getWeight (int ptnNo) {
  return weightArr_[ptnNo];
}


//release all memmory for this class
void release ();

//the destructor
virtual ~PtnLs ();

/******************************************************************************************
******************************************************************************************
******************************************************************************************
******************************************************************************************/
private:
//the list of all patterns
static Vec<Ptn> items_;

//the number of all patterns
static int nPtn_;

//number of sequences
static int nSeq_;

}; //end of class PtnLs

#endif // !defined(AFX_PATTERNLIST_H__0DE2B155_8E72_48D8_AA0E_CB07F7FE99BE__INCLUDED_)
