#ifndef TESTMETHOD_H
#define TESTMETHOD_H

#include "constant.h"

class TestMethod {
public :
void test ();
//--------------------------------------------------------------------
//we will init all things here before starting testing this method with data
void init ();

//--------------------------------------------------------------------
//set all paramaters of this class for Model class, Rate class
//--------------------------------------------------------------------
//set all paramaters of this class for Model class, Rate class
void setPam (DATA_TYPE dataType,
                         MODEL model,
                         double baseFrqA, double baseFrqC, double baseFrqG, double baseFrqT,
                         PAM_TYPE baseFrqType,     

                         double tsTvRatio,
                         PAM_TYPE tsTvRatioTpye,
           
                         double pyPuRatio,
                         PAM_TYPE pyPuRatioTpye,

                         double tsAG, double tsCT, double tvAC, double tvAT, double tvCG, double tvGT,
                         PAM_TYPE genPamType,
     
                         RATE_TYPE rateType,  
                         int nRate,

                         double gammaShape,
                         PAM_TYPE gammaShpeType);


//--------------------------------------------------------------------
/*do the quartet puzzling method for all data set from the input file
return the number of correct predicted tree
*/
int create ( const char *userTreeFile, const char *aliFile, 
                        int        nIter,       
                        double     probSel,
                        int        nRep,
                        STOPPING_TYPE     stoppingRule,
                        DATA_TYPE  dataType,
                        MODEL      model,
                        double      baseA, double baseC, double baseG, double baseT,
                        PAM_TYPE    baseFrqType,

                        double      tsTvRatio,
                        PAM_TYPE    tsTvRatioType,

			                  			double      pyPuRatio,
                        PAM_TYPE    pyPuRatioType,

                        double      tsAG, 
                        double      tsCT, 
                        double      tvAC, 
                        double      tvAT, 
                        double      tvCG, 
                        double      tvGT, 
                        PAM_TYPE    genPamType,

                        RATE_TYPE   rateType,
                        int         nRate,
                        
                        double      gammaShape,
                        PAM_TYPE    gammaShapeType,

                        int         outGrpSeqNo);

};

#endif
