#ifndef TREELS_H
#define TREELS_H

#include "vec.h"
#include "urtree.h"

class TreeLs {
public :

//the constructor function
TreeLs ();


//clean all content of this quartet puzzle tree list
void clean ();

/*it return 0, if there is not any the same Tree before
            1, otherwise */
int find (UrTree &tree);

int getSize ();
//the number of quartet puzzle trees
int nTree_;

//the list of all quartet puzzle trees up to now
typedef UrTree DUrTree;
Vec<DUrTree> items_;

int findRank (UrTree &tree);

//add the input tree into this list
void operator += (UrTree &tree);


//return items_[index]
UrTree & operator [] (const int index);

//set the limit for this list
void setLimit (int limit);

//release all memory of this class
void release ();

//the destructor function
virtual ~TreeLs ();
};

#endif
