#ifndef USERTREE_H
#define USERTREE_H

#include "urtree.h"

//this class HAVE NOT worked with the tree less than 4 external nodes

class UserTree : public UrTree {
public :

//the constructor function
UserTree ();

void setNewickTree (Vec<char> &newickTree);

//read the user tree from the file
void readFile (const char *userTreeFile);

//convert the newick tree form into the unrooted tree structure
int createUrTree ();

//the destructor function
virtual ~UserTree ();


/******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************/

private :
NEWICK_TREE_STATUS newickTreeStatus_;

//the input newick tree form
Vec<char> inputNewickTree_;

//register the newick tree form is a rooted or unrooted tree form
int isUrTreeForm_;

int isUrTreeForm (Vec<char> &newickTree);
//=======================================================
//check if it is a tree newick tree form
int isNewickTree (Vec<char> &newickTree);

/* (  (subTree0), (subTree1), (subTree2), ... )
find the  right sub tree point form the given point 
return -1, if not found*/
int findRightSubTreePoint (Vec<char> &newickTree, int startPoint);

/* (  (subTree0), (subTree1), (subTree2), ... )
compute the number of sub trees of this newick tree form*/
int cmpNumSubTree (Vec<char> &newickTree);


//compute the number external nodes of this newick tree form
int cmpNumExNd (Vec<char> &newickTree);

/*get the subtree of this newick tree. the subtree is end at rightPoint
return the leftPoint of this subtree in the newick tree */
int getSubTree (Vec<char> &newickTree, int rightPoint, Vec<char> &subTree, double &len);

//return 1, if this newickTree is a leaf tree
int isLeaf (Vec<char> &newickTree);

//decode the newick tree at an internal node
int decodeInNd (Vec<char> &newickTree, int parNdNo, int parBrNo);

//decode the newick tree at an external node
int decodeExNd (Vec<char> &newickTree, int parNdNo, int parBrNo);

}; //end of class

#endif

